#include <Wire.h>
#include "rgb_lcd.h"

rgb_lcd lcd;

const int colorR = 200;
const int colorG = 55;
const int colorB = 0;

//define the pins
int button = A0;
int mode = 11;
int address_data = 10;
int instructionNr = 12;
int led = 13;

int one = 9;
int two = 8;
int three = 7;
int four = 6;
int five = 5;
int six = 4;
int seven = 3;
int eight = 2;

//make a list for the output
int list[256];
int counter = 0;

//andere Variablen
int mode2;
int nr;
int ad; //address

int space = 0;
String instruction;

int registerA;
int registerB;

int registerC[8];
int registerD[8];

int jump = 0;
int jumpe = 0;
int jumpa = 0;
int jumpb = 0;
int j = 0;

int loopa = 0;

int lastState = 0;

int registerAS = 0;
int registerBS = 0;

void setup() {  
  lcd.begin(16, 2);
  lcd.setRGB(colorR, colorG, colorB);
  
  pinMode(led, OUTPUT);

  //display welcome
  lcd.setCursor(0, 0);
  lcd.print("Welcome to");
  lcd.setCursor(0, 1);
  lcd.print("Assembler!");
  digitalWrite(led, HIGH);
  delay(2000);
  digitalWrite(led, LOW);

  //define input pins
  pinMode(one, INPUT);
  pinMode(two, INPUT);
  pinMode(three, INPUT);
  pinMode(four, INPUT);
  pinMode(five, INPUT);
  pinMode(six, INPUT);
  pinMode(seven, INPUT);
  pinMode(eight, INPUT);
  pinMode(address_data, INPUT);
  pinMode(mode, INPUT);
  pinMode(button, INPUT);
  pinMode(instructionNr, INPUT);

  lcd.clear();
}

void loop() {  
  //query the pins
  int e = digitalRead(one);
  int z = digitalRead(two);
  int d = digitalRead(three);
  int v = digitalRead(four);
  int f = digitalRead(five);
  int se = digitalRead(six);
  int si = digitalRead(seven);
  int a = digitalRead(eight);
  
  //check mode
  mode2 = digitalRead(mode);
  
  if(mode2 == HIGH){ //programming mode
    lcd.clear();
    lastState = 0;
    j = 0;
    
    nr = digitalRead(instructionNr);
    
      
    ad = digitalRead(address_data);

    if(ad == HIGH){
      //print out instruction number
      lcd.setCursor(13, 1);
      lcd.print(counter + 1);
      
      //Decision
      if(e == HIGH && z == LOW && d == LOW && v == LOW && f == LOW && se == LOW && si == LOW && a == LOW){ //ADD
        //print number on lcd
        instruction = "00000001";
        lcd.setCursor(0, 0);
        lcd.print(instruction);
        lcd.setCursor(0, 1);
        lcd.print("ADD");
        if(digitalRead(button) == HIGH){
          list[counter] = 1;
          delay(500);
          counter++;
        }
      }
      if(e == LOW && z == HIGH && d == LOW && v == LOW && f == LOW && se == LOW && si == LOW && a == LOW){ //AND
        //print number on lcd
        instruction = "00000010";
        lcd.setCursor(0, 0);
        lcd.print(instruction);
        lcd.setCursor(0, 1);
        lcd.print("AND");
        if(digitalRead(button) == HIGH){
          list[counter] = 10;
          delay(500);
          counter++;
        }
      }
      if(e == HIGH && z == HIGH && d == LOW && v == LOW && f == LOW && se == LOW && si == LOW && a == LOW){ //JA<B
        //print number on lcd
        instruction = "00000011";
        lcd.setCursor(0, 0);
        lcd.print(instruction);
        lcd.setCursor(0, 1);
        lcd.print("JA<B");
        if(digitalRead(button) == HIGH){
          list[counter] = 11;
          delay(500);
          counter++;
          lcd.clear();
          jumpag();
        }
      }
      if(e == LOW && z == LOW && d == HIGH && v == LOW && f == LOW && se == LOW && si == LOW && a == LOW){ //JA>B
        //print number on lcd
        instruction = "00000100";
        lcd.setCursor(0, 0);
        lcd.print(instruction);
        lcd.setCursor(0, 1);
        lcd.print("JA>B");
        if(digitalRead(button) == HIGH){
          list[counter] = 100;
          delay(500);
          counter++;
          lcd.clear();
          jumpbg();
        }
      }
      if(e == HIGH && z == LOW && d == HIGH && v == LOW && f == LOW && se == LOW && si == LOW && a == LOW){ //DECA
        //print number on lcd
        instruction = "00000101";
        lcd.setCursor(0, 0);
        lcd.print(instruction);
        lcd.setCursor(0, 1);
        lcd.print("DECA");
        if(digitalRead(button) == HIGH){
          list[counter] = 101;
          delay(500);
          counter++;
        }
      }
      if(e == LOW && z == HIGH && d == HIGH && v == LOW && f == LOW && se == LOW && si == LOW && a == LOW){ //DECB
        //print number on lcd
        instruction = "00000110";
        lcd.setCursor(0, 0);
        lcd.print(instruction);
        lcd.setCursor(0, 1);
        lcd.print("DECB");
        if(digitalRead(button) == HIGH){
          list[counter] = 110;
          delay(500);
          counter++;
        }
      }
      if(e == HIGH && z == HIGH && d == HIGH && v == LOW && f == LOW && se == LOW && si == LOW && a == LOW){ //DIV
        //print number on lcd
        instruction = "00000111";
        lcd.setCursor(0, 0);
        lcd.print(instruction);
        lcd.setCursor(0, 1);
        lcd.print("DIV");
        if(digitalRead(button) == HIGH){
          list[counter] = 111;
          delay(500);
          counter++;
        }
      }
      if(e == LOW && z == LOW && d == LOW && v == HIGH && f == LOW && se == LOW && si == LOW && a == LOW){ //HLT
        //print number on lcd
        instruction = "00001000";
        lcd.setCursor(0, 0);
        lcd.print(instruction);
        lcd.setCursor(0, 1);
        lcd.print("HLT");
        if(digitalRead(button) == HIGH){
          list[counter] = 1000;
          delay(500);
          counter++;
        }
      }
      if(e == HIGH && z == LOW && d == LOW && v == HIGH && f == LOW && se == LOW && si == LOW && a == LOW){ //INCA
        //print number on lcd
        instruction = "00001001";
        lcd.setCursor(0, 0);
        lcd.print(instruction);
        lcd.setCursor(0, 1);
        lcd.print("INCA");
        if(digitalRead(button) == HIGH){
          list[counter] = 1001;
          delay(500);
          counter++;
        }
      }
      if(e == LOW && z == HIGH && d == LOW && v == HIGH && f == LOW && se == LOW && si == LOW && a == LOW){ //INCB
        //print number on lcd
        instruction = "00001010";
        lcd.setCursor(0, 0);
        lcd.print(instruction);
        lcd.setCursor(0, 1);
        lcd.print("INCB");
        if(digitalRead(button) == HIGH){
          list[counter] = 1010;
          delay(500);
          counter++;
        }
      }
      if(e == HIGH && z == HIGH && d == LOW && v == HIGH && f == LOW && se == LOW && si == LOW && a == LOW){ //JE
        //print number on lcd
        instruction = "00001011";
        lcd.setCursor(0, 0);
        lcd.print(instruction);
        lcd.setCursor(0, 1);
        lcd.print("JE");
        if(digitalRead(button) == HIGH){
          list[counter] = 1011;
          delay(500);
          counter++;
          lcd.clear();
          jumpeq();
        }
      }
      if(e == LOW && z == LOW && d == HIGH && v == HIGH && f == LOW && se == LOW && si == LOW && a == LOW){ //JMP
        //print number on lcd
        instruction = "00001100";
        lcd.setCursor(0, 0);
        lcd.print(instruction);
        lcd.setCursor(0, 1);
        lcd.print("JMP");
        if(digitalRead(button) == HIGH){
          list[counter] = 1100;
          delay(500);
          counter++;
          lcd.clear();
          jumpx();
        }
      }
      if(e == HIGH && z == LOW && d == HIGH && v == HIGH && f == LOW && se == LOW && si == LOW && a == LOW){ //LDA
        //print number on lcd
        instruction = "00001101";
        lcd.setCursor(0, 0);
        lcd.print(instruction);
        lcd.setCursor(0, 1);
        lcd.print("LDA");
        if(digitalRead(button) == HIGH){
          list[counter] = 1101;
          delay(500);
          counter++;
          lcd.clear();
          lda();
        }
      }
      if(e == LOW && z == HIGH && d == HIGH && v == HIGH && f == LOW && se == LOW && si == LOW && a == LOW){ //LDB
        //print number on lcd
        instruction = "00001110";
        lcd.setCursor(0, 0);
        lcd.print(instruction);
        lcd.setCursor(0, 1);
        lcd.print("LDB");
        if(digitalRead(button) == HIGH){
          list[counter] = 1110;
          delay(500);
          counter++;
          lcd.clear();
          ldb();
        }
      }
      if(e == HIGH && z == HIGH && d == HIGH && v == HIGH && f == LOW && se == LOW && si == LOW && a == LOW){ //LOOP
        //print number on lcd
        instruction = "00001111";
        lcd.setCursor(0, 0);
        lcd.print(instruction);
        lcd.setCursor(0, 1);
        lcd.print("LOOP");
        if(digitalRead(button) == HIGH){
          list[counter] = 1111;
          delay(500);
          counter++;
          lcd.clear();
          loopx();
        }
      }
      if(e == LOW && z == LOW && d == LOW && v == LOW && f == HIGH && se == LOW && si == LOW && a == LOW){ //MUL
        //print number on lcd
        instruction = "00010000";
        lcd.setCursor(0, 0);
        lcd.print(instruction);
        lcd.setCursor(0, 1);
        lcd.print("MUL");
        if(digitalRead(button) == HIGH){
          list[counter] = 10000;
          delay(500);
          counter++;
        }
      }
      if(e == HIGH && z == LOW && d == LOW && v == LOW && f == HIGH && se == LOW && si == LOW && a == LOW){ //NOT
        //print number on lcd
        instruction = "00010001";
        lcd.setCursor(0, 0);
        lcd.print(instruction);
        lcd.setCursor(0, 1);
        lcd.print("NOT");
        if(digitalRead(button) == HIGH){
          list[counter] = 10001;
          delay(500);
          counter++;
        }
      }
      if(e == LOW && z == HIGH && d == LOW && v == LOW && f == HIGH && se == LOW && si == LOW && a == LOW){ //OR
        //print number on lcd
        instruction = "00010010";
        lcd.setCursor(0, 0);
        lcd.print(instruction);
        lcd.setCursor(0, 1);
        lcd.print("OR");
        if(digitalRead(button) == HIGH){
          list[counter] = 10010;
          delay(500);
          counter++;
        }
      }
      if(e == HIGH && z == HIGH && d == LOW && v == LOW && f == HIGH && se == LOW && si == LOW && a == LOW){ //OUTA
        //print number on lcd
        instruction = "00010011";
        lcd.setCursor(0, 0);
        lcd.print(instruction);
        lcd.setCursor(0, 1);
        lcd.print("OUTA");
        if(digitalRead(button) == HIGH){
          list[counter] = 10011;
          delay(500);
          counter++;
        }
      }
      if(e == LOW && z == LOW && d == HIGH && v == LOW && f == HIGH && se == LOW && si == LOW && a == LOW){ //OUTB
        //print number on lcd
        instruction = "00010100";
        lcd.setCursor(0, 0);
        lcd.print(instruction);
        lcd.setCursor(0, 1);
        lcd.print("OUTB");
        if(digitalRead(button) == HIGH){
          list[counter] = 10100;
          delay(500);
          counter++;
        }
      }
      if(e == HIGH && z == LOW && d == HIGH && v == LOW && f == HIGH && se == LOW && si == LOW && a == LOW){ //SUB
        //print number on lcd
        instruction = "00010101";
        lcd.setCursor(0, 0);
        lcd.print(instruction);
        lcd.setCursor(0, 1);
        lcd.print("SUB");
        if(digitalRead(button) == HIGH){
          list[counter] = 10101;
          delay(500);
          counter++;
        }
      }
      if(e == LOW && z == HIGH && d == HIGH && v == LOW && f == HIGH && se == LOW && si == LOW && a == LOW){ //DELAY
        //print number on lcd
        instruction = "00010110";
        lcd.setCursor(0, 0);
        lcd.print(instruction);
        lcd.setCursor(0, 1);
        lcd.print("DELAY");
        if(digitalRead(button) == HIGH){
          list[counter] = 10110;
          delay(500);
          counter++;
        }
      }

      
    }
    if(ad == LOW){ //show current value
      lcd.setCursor(0, 0);
      lcd.print("CURRENT VALUE:");              
      lcd.setCursor(0, 1);
      lcd.print(number());
    }

    
  }if(mode2 == LOW){ //Run mode
    if(lastState == 0){
      lcd.clear();
      registerA = registerAS;
      registerB = registerBS;
      lastState = 1;
    }
    
    lcd.setCursor(0, 0);
    lcd.print("OUTPUT:");

    while(j < 256){
      if(digitalRead(mode2) == HIGH){
        j = 0;
        break;
      }
      if(list[j] == 1){ //ADD
        add();
        j++;
      }
      if(list[j] == 10){ //AND
        anda();
        j++;
      }
      if(list[j] == 11){ //JA<B
        if(registerA < registerB){
          j = jumpa;
        }else{
          j++;
        }
      }
      if(list[j] == 100){ //JA>B
        if(registerA > registerB){
          j = jumpb;
        }else{
          j++;
        }
      }
      if(list[j] == 101){ //DECA
        decA();
        j++;
      }
      if(list[j] == 110){ //DECB
        decB();
        j++;
      }
      if(list[j] == 111){ //DIV
        divide();
        j++;
      }
      if(list[j] == 1000){ //HLT
        j = 256;
      }
      if(list[j] == 1001){ //INCA
        incA();
        j++;
      }
      if(list[j] == 1010){ //INCB
        incB();
        j++;
      }
      if(list[j] == 1011){ //JE
        if(registerA == registerB){
          j = jumpe;
        }else{
          j++;
        }
      }
      if(list[j] == 1100){ //JMP
        j = jump;
      }
      if(list[j] == 1101){ //LDA
        j++;
      }
      if(list[j] == 1110){ //LDB
        j++;
      }
      if(list[j] == 1111){ //LOOP
        if(registerA - 1 > 0){
          registerA -= 1;
          j = loopa;
        }else{
          j++;
        }
      }
      if(list[j] == 10000){ //MUL
        mul();
        j++;
      }
      if(list[j] == 10001){ //NOT
        nota();
        j++;
      }
      if(list[j] == 10010){ //OR
        ora();
        j++;
      }
      if(list[j] == 10011){ //OUTA
        outA();
        j++;
      }
      if(list[j] == 10100){ //OUTB
        outB();
        j++;
      }
      if(list[j] == 10101){ //SUB
        sub();
        j++;
      }
      if(list[j] == 10110){ //DELAY
        delay(1000);
        j++;
      }
    }
  }
  delay(300);
}

void loopx(){
  while(true){
    lcd.setCursor(0, 0);
    lcd.print("Line:");
    binary(number(), 7, 0);
    if(digitalRead(button) == HIGH){
      loopa = number() - 1;
      delay(500);
      break;
    }
    delay(200);
  }
}

void jumpbg(){
  while(true){
    lcd.setCursor(0, 0);
    lcd.print("Line:");
    binary(number(), 7, 0);
    if(digitalRead(button) == HIGH){
      jumpb = number() - 1;
      delay(500);
      break;
    }
    delay(200);
  }
}

void jumpag(){
  while(true){
    lcd.setCursor(0, 0);
    lcd.print("Line:");
    binary(number(), 7, 0);
    if(digitalRead(button) == HIGH){
      jumpa = number() - 1;
      delay(500);
      break;
    }
    delay(200);
  }
}

void jumpeq(){
  while(true){
    lcd.setCursor(0, 0);
    lcd.print("Line:");
    binary(number(), 7, 0);
    if(digitalRead(button) == HIGH){
      jumpe = number() - 1;
      delay(500);
      break;
    }
    delay(200);
  }
}

void jumpx(){
  while(true){
    lcd.setCursor(0, 0);
    lcd.print("Line:");
    binary(number(), 7, 0);
    if(digitalRead(button) == HIGH){
      jump = number() - 1;
      delay(500);
      break;
    }
    delay(200);
  }
}

void incA(){
  if(registerA < 255){
    registerA += 1;
  }else{
    registerA = 0;
  }
}

void incB(){
  if(registerB < 255){
    registerB += 1;
  }else{
    registerB = 0;
  }
}

void decA(){
  if(registerA > 0){
    registerA -= 1;
  }else{
    registerA = 255;
  }
}

void decB(){
  if(registerB > 0){
    registerB -= 1;
  }else{
    registerB = 255;
  }
}

int nota(){
  for(int j = 0; j < 8; j++){
    registerC[j] = registerA % 2;
    registerA = registerA / 2;
  }
  
  int c[8];

  for(int j = 0; j < 8; j++){
    if(registerC[j] == 1){
      c[j] = 0;
    }else{
      c[j] = 1;
    }
  }

  int d = numberAddition(c);
  registerA = d;
  return d;
}

int anda(){
  for(int j = 0; j < 8; j++){
    registerC[j] = registerA % 2;
    registerA = registerA / 2;
  }

  for(int j = 0; j < 8; j++){
    registerD[j] = registerB % 2;
    registerB = registerB / 2;
  }
  
  int c[8];

  for(int j = 0; j < 8; j++){
    if(registerC[j] == 1 && registerD[j] == 1){
      c[j] = 1;
    }
  }

  int d = numberAddition(c);
  registerA = d;
  return d;
}

int ora(){
  for(int j = 0; j < 8; j++){
    registerC[j] = registerA % 2;
    registerA = registerA / 2;
  }

  for(int j = 0; j < 8; j++){
    registerD[j] = registerB % 2;
    registerB = registerB / 2;
  }
  
  int c[8];

  for(int j = 0; j < 8; j++){
    if(registerC[j] == 1 || registerD[j] == 1){
      c[j] = 1;
    }
  }

  int d = numberAddition(c);
  registerA = d;
  return d;
}

void outA(){
  binary(registerA, 0, 1);
}

void outB(){
  binary(registerB, 0, 1);
}

int add(){
  int i = registerA + registerB;
  registerA = i;
  return i;
}

int divide(){
  int i = registerA / registerB;
  registerA = i;
  return i;
}

int mul(){
  int i = registerA * registerB;
  registerA = i;
  return i;
}

int sub(){
  int i = registerA - registerB;
  registerA = i;
  return i;
}

void lda(){
  while(true){
    lcd.setCursor(0, 0);
    lcd.print("Data:");
    binary(number(), 7, 0);
    if(digitalRead(button) == HIGH){
      registerA = number();
      registerAS = registerA;
      delay(500);
      break;
    }
    delay(200);
  }
}

void ldb(){
  while(true){
    lcd.setCursor(0, 0);
    lcd.print("Data:");
    binary(number(), 7, 0);
    if(digitalRead(button) == HIGH){
      registerB = number();
      registerBS = registerB;
      delay(500);
      break;
    }
    delay(200);
  }
}

int number(){
  //scan pins
  int ei = digitalRead(one);
  int zw = digitalRead(two);
  int dr = digitalRead(three);
  int vi = digitalRead(four);
  int fu = digitalRead(five);
  int sec = digitalRead(six);
  int sie = digitalRead(seven);
  int ac = digitalRead(eight);

  //add
  int i = 0;
  if(ei == HIGH){
    i += 1;
  }
  if(zw == HIGH){
    i += 2;
  }
  if(dr == HIGH){
    i += 4;
  }
  if(vi == HIGH){
    i += 8;
  }
  if(fu == HIGH){
    i += 16;
  }
  if(sec == HIGH){
    i += 32;
  }
  if(sie == HIGH){
    i += 64;
  }
  if(ac == HIGH){
    i += 128;
  }
  return i;
}

int numberAddition(int i[8]){
  int k = 0;
  if(i[0] == 1){
    k += 1;
  }
  if(i[1] == 1){
    k += 2;
  }
  if(i[2] == 1){
    k += 4;
  }
  if(i[3] == 1){
    k += 8;
  }
  if(i[4] == 1){
    k += 16;
  }
  if(i[5] == 1){
    k += 32;
  }
  if(i[6] == 1){
    k += 64;
  }
  if(i[7] == 1){
    k += 128;
  }
  return k;
}

void binary(int i, int cursorPlace, int line){
  int number[8];
  for(int j = 0; j < 8; j++){
    number[j] = i % 2;
    i = i / 2;
  }
  
  for(int j = 7; j >= 0; j--){
    lcd.setCursor(cursorPlace, line);
    lcd.print(number[j]);
    cursorPlace++;
  }
}
